Index: trunk/expressoMail1_2/inc/class.imap_functions.inc.php
===================================================================
--- trunk/expressoMail1_2/inc/class.imap_functions.inc.php	(revision 5083)
+++ trunk/expressoMail1_2/inc/class.imap_functions.inc.php	(revision 5134)
@@ -2941,165 +3604,132 @@
 	}
 
+
 	function save_msg($params)
 	{
-
-		include_once("class.phpmailer.php");
-		$mail = new PHPMailer();
-		include_once("class.db_functions.inc.php");
-		$toaddress = $params['input_to'];
-		$ccaddress = $params['input_cc'];
-		$ccoaddress = $params['input_cco'];
+		require_once $_SESSION['rootPath'] . '/API/class.servicelocator.php';
+		$mailService = ServiceLocator::getService('mail');
+
 		$return_receipt = $params['input_return_receipt'];
 		$is_important = $params['input_important_message'];
-		$subject = $params['input_subject'];
+		
 		$msg_uid = $params['msg_id'];
 		$body = $params['body'];
 		$body = str_replace("%nbsp;","&nbsp;",$body);
 		$body = preg_replace("/\n/"," ",$body);
-		$body = preg_replace("/\r/","",$body);
+		$body = preg_replace("/\r/","" ,$body);
+		$body = html_entity_decode ( $body, ENT_QUOTES , 'ISO-8859-1' );
 		$forwarding_attachments = $params['forwarding_attachments'];
+		$message_attachments    = $params['message_attachments'];
 		$attachments = $params['FILES'];
 		$return_files = $params['FILES'];
+		$message_attachments_contents = (isset($params['message_attachments_content'])) ? $params['message_attachments_content'] : false; 
 
                 if(is_array($params['local_attachments'])){
                     foreach ($params['local_attachments'] as $key => $local_attach) {
                        $tmp = unserialize(urldecode($local_attach));
-                       $attachments[$key]['name'] = $tmp[2];
-                       $return_files[$key]['name'] = $tmp[2];
+			   $attachments[$key]['name'] = urldecode($tmp[2]);
+			   $return_files[$key]['name'] = urldecode($tmp[2]);
                     }
                 }
 
-
-		$folder = $params['folder'];
-		$folder = mb_convert_encoding($folder, "UTF7-IMAP","ISO_8859-1");
-		// Fix problem with cyrus delimiter changes.
-		// Dots in names: enabled/disabled.
-		$folder = @eregi_replace("INBOX/", "INBOX".$this->imap_delimiter, $folder);
-		$folder = @eregi_replace("INBOX.", "INBOX".$this->imap_delimiter, $folder);
-		// End Fix.
-
-		$mail->SaveMessageInFolder = $folder;
-		$mail->SMTPDebug = false;
-
-		$mail->IsSMTP();
-		$mail->Host = $_SESSION['phpgw_info']['expressomail']['email_server']['smtpServer'];
-		$mail->Port = $_SESSION['phpgw_info']['expressomail']['email_server']['smtpPort'];
-		$mail->From = $_SESSION['phpgw_info']['expressomail']['user']['email'];
-		$mail->FromName = $_SESSION['phpgw_info']['expressomail']['user']['fullname'];
-
-		$mail->Sender = $mail->From;
-		$mail->SenderName = $mail->FromName;
-		$mail->FromName = $_SESSION['phpgw_info']['expressomail']['user']['fullname'];
-		$mail->From =  $_SESSION['phpgw_info']['expressomail']['user']['email'];
-
-		$this->add_recipients("to", $toaddress, &$mail);
-		$this->add_recipients("cc", $ccaddress, &$mail);
-                $this->add_recipients("cco", $ccoaddress, &$mail);
-		$mail->AddReplyTo($replytoaddress);
-		$mail->Subject = $subject;
-		$mail->IsHTML(true);
-		$mail->Body = $body;
-		
-		$return_forward = $this->buildEmbeddedImages($mail,$msg_uid,$forwarding_attachments);
+		$folder = mb_convert_encoding($params['folder'], "UTF7-IMAP","ISO_8859-1");
+		$folder = @eregi_replace("INBOX[/.]", "INBOX".$this->imap_delimiter, $folder);
+
+		$mailService->setFrom ('"'.$fromaddress[0].'" <'.$fromaddress[1].'>');
+		$mailService->addTo($params['input_to']);
+		$mailService->addCc( $params['input_cc']);
+		$mailService->addBcc($params['input_cco']);
+		$mailService->setSubject($params['input_subject']);
+
+		if($is_important){
+			$mailService->addHeaderField('Importance','High');
+		}
+
+		if($return_receipt)
+			$mailService->addHeaderField('Disposition-Notification-To', $_SESSION['phpgw_info']['expressomail']['user']['email']);
+
+		$isHTML = ( ( array_key_exists( 'type', $params ) && in_array( strtolower( $params[ 'type' ] ), array( 'html', 'plain' ) ) ) ? strtolower( $params[ 'type' ] ) != 'plain' : true );
+
+		
+		if( count($forwarding_attachments) > 0 )
+			$return_forward = $this->buildEmbeddedImages($mailService, $msg_uid, $forwarding_attachments , $body);
+			
+		//Build Message Attachments!!!
+		if(count($message_attachments) > 0 ) 
+		{
+			foreach($message_attachments as $folder_name => $messages)
+			{
+				foreach ($messages as $message_number => $message_subject) 
+				{
+					if (!$message_subject)
+						$message_subject  = 'no title.eml';
+					else 
+						$message_subject .= '.eml';
+					
+					if( $message_attachments_contents &&  isset($message_attachments_contents[$folder_name]) )
+						$rawmsg = base64_decode( $message_attachments_contents[$folder_name][$message_number] );
+					else{
+						$mbox_stream = $this->open_mbox($folder_name);$mbox_stream = $this->open_mbox($folder_name);
+						$rawmsg = $this->getRawHeader($message_number) . "\r\n\r\n" . $this->getRawBody($message_number);
+					}
+											
+					$return_forward[] = array( 'name' => $message_subject, 'size' => mb_strlen($rawmsg));
+					$mailService->addStringAttachment($rawmsg, $message_subject, 'message/rfc822', '7bit', 'attachment' );
+				}
+			}
+		}
+		
 		$imagesParts = array(); 
 
+		if(count($return_forward) > 0 )
 		foreach ($return_forward as $value)
 			$imagesParts[$value[6]] = $value[3]; 	
 
-	//	Build Forwarding Attachments!!!
+		//Build Forwarding Attachments!!!
+		if(count($forwarding_attachments) > 0 ) 
+		{
 			foreach($forwarding_attachments as $forwarding_attachment)
 			{
 				$file_description = unserialize(rawurldecode($forwarding_attachment));
+						
+				
 			$file_description = array_values($file_description); 
  	                          	
-				foreach($file_description as $i => $descriptor){
+				foreach($file_description as $i => $descriptor)
   	  	 	                                $file_description[$i] = eregi_replace('\'*\'','',$descriptor); 
-				}
+				
 				$fileContent = $this->get_forwarding_attachment($file_description[0], $file_description[1], $file_description[3],$file_description[4]);
-				$fileName = $file_description[2];
+				$file_description[2] = html_entity_decode($file_description[2]);
 
 				$file_description[5] = strlen($fileContent); //Size of file
 				$return_forward[] = $file_description;
-
-					$mail->AddStringAttachment($fileContent, $fileName, $file_description[4], $this->get_file_type($file_description[2]));
+				$mailService->addStringAttachment($fileContent, $file_description[2], $this->get_file_type($file_description[2]), $file_description[4] );
+			}
 			}
 
 		if ((count($return_forward) > 0) && (count($return_files) > 0))
-		{
 			$return_files = array_merge_recursive($return_forward,$return_files);
-		}
 		else if (count($return_files) < 1)
-		{
 				$return_files = $return_forward;
-		}
-
-		//	Build Uploading Attachments!!!
+
+		//Build Uploading Attachments!!!
 		$sizeof_attachments = count($attachments);
 		if ($sizeof_attachments)
-		{
 			foreach ($attachments as $numb => $attach)
-			{
-				if ($numb == ($sizeof_attachments-1) && $params['insertImg'] == 'true')
-				{ // Auto-resize image
-					list($width, $height,$image_type) = getimagesize($attach['tmp_name']);
-					switch ($image_type)
-					{
-					// Do not corrupt animated gif
-					//case 1: $image_big = imagecreatefromgif($attach['tmp_name']);break;
-						case 2: 
-							$image_big = imagecreatefromjpeg($attach['tmp_name']);  break;
-						case 3: 
-							$image_big = imagecreatefrompng($attach['tmp_name']); break;
-					case 6:
-						require_once("gd_functions.php");
-						$image_big = imagecreatefrombmp($attach['tmp_name']); break;
-					default:
-						$mail->AddAttachment($attach['tmp_name'], $attach['name'], "base64", $this->get_file_type($attach['name']));
-						break;
-					}
-					header('Content-type: image/jpeg');
-					$max_resolution = $_SESSION['phpgw_info']['user']['preferences']['expressoMail']['image_size'];
-					$max_resolution = ($max_resolution==""?'65536':$max_resolution);
-					if ($width < $max_resolution && $height < $max_resolution)
-					{
-						$new_width = $width;
-						$new_height = $height;
-					}
-					else if ($width > $max_resolution)
-					{
-						$new_width = $max_resolution;
-						$new_height = $height*($new_width/$width);
-					}
-					else 
-					{
-						$new_height = $max_resolution;
-						$new_width = $width*($new_height/$height);
-					}
-					$image_new = imagecreatetruecolor($new_width, $new_height);
-					imagecopyresampled($image_new, $image_big, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
-                                        $tmpDir = '/tmp';
-
-                                       // $tmpDir = ini_get("session.save_path");
-					$_file = "/cidimage_".$_SESSION[ 'phpgw_session' ][ 'session_id' ].".dat";
-					imagejpeg($image_new,$tmpDir.$_file, 85);
-					$mail->AddAttachment($tmpDir.$_file, $attach['name'], "base64", $this->get_file_type($tmpDir.$_file));
-				}else{
-					$mail->AddAttachment($attach['tmp_name'], $attach['name'], "base64", $this->get_file_type($attach['name']));
-                                }// optional name
-			}
-		}
-
-		if(!empty($mail->AltBody))
-            $mail->ContentType = "multipart/alternative";
-
-		$mail->error_count = 0; // reset errors
-		$mail->SetMessageType();
-		$header = $mail->CreateHeader();
-		$body = $mail->CreateBody();
+				$mailService->addFileAttachment($attach['tmp_name'],  $attach['name'],$attach['type'],  'base64', 'attachment');
+
+
+		if (!$body)
+			$body = ' ';
+		
+		if($isHTML)
+			$mailService->setBodyHtml($body);
+		else
+			$mailService->setBodyText($body);
+
 
 		$mbox_stream = $this->open_mbox($folder);
-		$new_header = str_replace("\n", "\r\n", $header);
-		$new_body = str_replace("\n", "\r\n", $body);
-		$return['append'] = imap_append($mbox_stream, "{".$this->imap_server.":".$this->imap_port."}".$folder, $new_header . $new_body, "\\Seen \\Draft");
+		$return['append'] = imap_append($mbox_stream, "{".$this->imap_server.":".$this->imap_port."}".$folder, $mailService->getMessage(), "\\Seen \\Draft");
+
 		$status = imap_status($mbox_stream, "{".$this->imap_server.":".$this->imap_port."}".$folder, SA_UIDNEXT);
 		$return['msg_no'] = $status->uidnext - 1;
@@ -3110,5 +3740,8 @@
 			imap_close($mbox_stream);
 			
-		if (is_array($return_files))
+		$returnFiles = array();                  
+		$ii = 0;
+                		
+		if(count($return_files) > 0)
 		{
 			foreach ($return_files as $index => $_attachment) 
@@ -3116,21 +3749,19 @@
 				if (array_key_exists("name", $_attachment))
 				{
-				unset($return_files[$index]);
-				$return_files[$index] = $_attachment['name']."_SIZE_".$return_files[$index][1] = $_attachment['size'];
-			}
-			else
+					$returnFiles[$ii]['name'] = base64_encode($_attachment['name']);
+					$returnFiles[$ii]['size'] = $_attachment['size'];
+					$ii++;
+			}
+				else if($_attachment[2])
 			{
-				unset($return_files[$index]);
-				$return_files[$index] = $_attachment[2]."_SIZE_". $return_files[$index][1] = $_attachment[5];
-			}
-		}
-		}
-
-		$return['files'] = serialize($return_files);
-		$return["subject"] = $subject;
-
-		if (!$return['append'])
-			$return['append'] = imap_last_error();
-
+					$returnFiles[$ii]['name'] = base64_encode($_attachment[2]); 
+					$returnFiles[$ii]['size'] = $_attachment[5];         
+					$ii++;
+			}
+		}
+		}
+		$return['files'] = serialize($returnFiles);
+		$return["subject"] = $params['input_subject'];
+		if (!$return['append'])	$return['append'] = imap_last_error();
 		return $return;
 	}
@@ -3139,20 +3770,9 @@
 	{
 		$folder = $params['folder'];
-		$rowids_to_set = $params['msgs_to_set']; // contains the row ids
+		$msgs_to_set = $params['msgs_to_set'];
 		$flag = $params['flag'];
 		$return = array();
-		$return["rowids_to_set"] = $rowids_to_set;
+		$return["msgs_to_set"] = $msgs_to_set;
 		$return["flag"] = $flag;
-
-		$msgs_to_set = '';
-		foreach (explode(',',$rowids_to_set) as $msg) {//extracting message ids
-			$pos = strpos($msg,'_');
-			if ($pos===false)
-				$msgs_to_set .= ','.$msg;
-			else
-				$msgs_to_set .= ','.substr($msg,0,$pos);
-		}
-		$msgs_to_set = substr($msgs_to_set,1);
-		$return["msgs_to_set"] = $msgs_to_set;
 
 		if(!$this->mbox && !is_resource($this->mbox))
@@ -3213,4 +3833,6 @@
 		$file_name = strtolower($file_name);
 	   	$strFileType = strrev(substr(strrev($file_name),0,4));
+	   	if ($strFileType == ".eml")
+   			return "message/rfc822";
 	   	if ($strFileType == ".asf")
    			return "video/x-ms-asf";
@@ -3710,7 +4332,5 @@
 							{
 							    $filter .= '"'.$filter_array[1].'"';
-							}
-							if(trim($filter_array[0]) == 'BEFORE' )
-							{
+							}else if(trim($filter_array[0]) == 'BEFORE' ){
                                                             $filter .= '"'.$this->make_search_date($filter_array[1],true).'"';
 							}else{
@@ -3721,5 +4341,5 @@
 				}
 				
-				$name_box = mb_convert_encoding(utf8_decode($name_box), "UTF7-IMAP", "ISO_8859-1" );
+				$name_box = mb_convert_encoding(utf8_decode($name_box), "UTF7-IMAP", "ISO-8859-1" );
 				$filter = $this->remove_accents($filter);
 
@@ -3737,5 +4357,5 @@
 				}
 				else
-					$folder_name = mb_convert_encoding(utf8_decode($name_box), "UTF7-IMAP", "ISO_8859-1" );
+					$folder_name = mb_convert_encoding(utf8_decode($name_box), "UTF7-IMAP", "ISO-8859-1" );
 				
 				if(!is_resource($mbox_stream))
@@ -3760,5 +4380,5 @@
 							{
 								$elem = $this->get_msg_detail($new_search,$name_box,$mbox_stream); 
-								$elem['boxname'] = mb_convert_encoding( $name_box, "ISO_8859-1", "UTF7-IMAP" ); 
+								$elem['boxname'] = mb_convert_encoding( $name_box, "ISO-8859-1", "UTF7-IMAP" ); 
 								$elem['uid'] = $new_search;
                                                                 /* compare dates in ordering */
@@ -3770,4 +4390,5 @@
 				}
 				else{
+					$search_criteria = imap_search($mbox_stream, $filter, SE_UID);
                                     if($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['use_important_flag'])
                                     {
@@ -3785,26 +4406,17 @@
                                                 }
                                             }
-
-                                            $new_filter = trim(preg_replace('/UNFLAGGED|FLAGGED/','',$filter));
-
-                                            $search_without_flagged = imap_search($mbox_stream, $new_filter, SE_UID);
-
-                                            if (strpos($filter,"UNFLAGGED") === false)
+						if((count($flagged_msgs) >0) && (strpos($filter,"UNFLAGGED") === false))
                                             {
-                                                $search_criteria = array_intersect($search_without_flagged, $flagged_msgs);
-                                            }
-                                            else
+                                                    $arry_diff = is_array($search_criteria) ? array_diff($flagged_msgs,$search_criteria):$flagged_msgs;
+                                                    foreach($arry_diff as $msg)
                                             {
-                                                $search_criteria = array_diff($search_without_flagged,$flagged_msgs);
+							$search_criteria[] = $msg;
                                             }
                                         }
-                                        else
+						else if((count($flagged_msgs) >0) && (is_array($search_criteria)) && (!strpos($filter,"UNFLAGGED") === false))
                                         {
-                                            $search_criteria = imap_search($mbox_stream, $filter, SE_UID);
+                                                    $search_criteria = array_diff($search_criteria,$flagged_msgs);
                                         }
                                     }
-                                    else
-                                    {
-                                        $search_criteria = imap_search($mbox_stream, $filter, SE_UID);
                                     }
 
@@ -3814,5 +4426,5 @@
                                         {
                                             $elem = $this->get_msg_detail($new_search,$name_box,$mbox_stream);
-                                            $elem['boxname'] = mb_convert_encoding( $name_box, "ISO_8859-1", "UTF7-IMAP" );
+							$elem['boxname'] = mb_convert_encoding( $name_box, "ISO-8859-1", "UTF7-IMAP" ); 
                                             $elem['uid'] = $new_search;
                                             /* compare dates in ordering */
@@ -4036,6 +4648,9 @@
 		$mbox_acl = imap_getacl($mbox_stream, 'user'.$this->imap_delimiter.$user);
 		else
-		  $mbox_acl = imap_getacl($mbox_stream, $user);
+		  $mbox_acl = @imap_getacl($mbox_stream, $user);
+                if(isset($mbox_acl[$this->username]))
 		return $mbox_acl[$this->username];
+                else 
+                    return '';
 	}
 
@@ -4166,4 +4781,15 @@
 	
 	
+/**
+* Descrição do método
+*
+* @license    http://www.gnu.org/copyleft/gpl.html GPL
+* @author     
+* @sponsor    Caixa Econômica Federal
+* @author     
+* @param      <tipo> <$msg_number> <Número da mensagem>
+* @return     <cabeçalho da mensagem>
+* @access     <public>
+*/	
 	function get_header($msg_number)
 	{
@@ -4172,5 +4798,5 @@
 			return false;
 
-		if($header->Flagged != "F" && $_SESSION['phpgw_info']['user']['preferences']['expressoMail']['use_important_flag']) {
+		if($header->Flagged != "F" ) {
 			$flag = preg_match('/importance *: *(.*)\r/i',
 						imap_fetchheader($this->mbox, imap_msgno($this->mbox, $msg_number))
@@ -4191,9 +4817,12 @@
         $imap_port 	= $_SESSION['phpgw_info']['expressomail']['email_server']['imapPort'];
         $imap_options = '/notls/novalidate-cert';
+
+	
+        $folder = mb_convert_encoding( $folder, "UTF7-IMAP","ISO-8859-1");
+
         $mbox_stream = imap_open("{".$imap_server.":".$imap_port.$imap_options."}".$folder, $username, $password);
-        if(imap_last_error())
-        {
+        
+        if(imap_last_error() === 'Mailbox already exists')
             imap_createmailbox($mbox_stream,imap_utf7_encode("{".$imap_server."}".$folder));
-       	}
         if($timestamp){
 			$pdate = date_parse(date('r')); // pega a data atual do servidor (TODO: pegar a data da mensagem local) 
@@ -4205,6 +4834,6 @@
         	fputs($f,base64_encode($source));
             fclose($f);
-		   $command = "python ".$_SESSION['rootPatch']."/expressoMail1_2/imap.py ".escapeshellarg($imap_server)." ".escapeshellarg($imap_port)." ".escapeshellarg($username)." ".escapeshellarg($password)." ".escapeshellarg($timestamp)." ".escapeshellarg($folder)." ".escapeshellarg($file);
-            $return['command']=exec(escapeshellcmd($command));
+            $command = "python ".$_SESSION['rootPath']."/expressoMail1_2/imap.py \"$imap_server\" \"$imap_port\" \"$username\" \"$password\" \"$timestamp\" \"$folder\" \"$file\"";
+            $return['command']= exec($command);
         }else{
             $return['append'] = imap_append($mbox_stream, "{".$imap_server.":".$imap_port."}".$folder, $source, "\\Seen");
@@ -4230,4 +4859,9 @@
                   imap_setflag_full($mbox_stream, $return['msg_no'], $flags_fixed, ST_UID);
                 }
+	
+        //Ignorando erro de AUTH=Plain
+        if($return['error'] === 'SECURITY PROBLEM: insecure server advertised AUTH=PLAIN')
+            $return['error'] = false;
+                                
         if($mbox_stream)
             imap_close($mbox_stream);
@@ -4235,18 +4869,20 @@
     }
 
-    function show_decript($params){
+        function show_decript($params,$dec=0){ 
         $source = $params['source'];
-        //error_log("source: $source\nversao: " . PHP_VERSION, 3, '/tmp/teste.log'); 
- 		        $source = str_replace(" ", "+", $source,$i); 
  		 
+        //error_log("source: $source\nversao: " . PHP_VERSION); 	 
+        if ($dec == 0) 
+        { 
+            $source = str_replace(" ", "+", $source,$i); 
  		        if (version_compare(PHP_VERSION, '5.2.0', '>=')){ 
  		            if(!$source = base64_decode($source,true)) 
- 		                return "error ".$source."Espaços ".$i; 
+                    return "error ".$source."Espaï¿?os ".$i; 
  		 
  		        } 
  		        else { 
  		            if(!$source = base64_decode($source)) 
- 		                return "error ".$source."Espaços ".$i;
-
+                    return "error ".$source."Espaï¿?os ".$i; 
+            } 
         }
 
@@ -4316,16 +4952,14 @@
         $dest_folder = $params['folder'];
         $sources = explode("#@#@#@",$params['source']);
-        $timestamps = explode("#@#@#@",$params['timestamp']);
+        //Add user timeszone
+        $timestamps 	= $params['timestamp'] + $this->functions->CalculateDateOffset(); 
         $flags = explode("#@#@#@",$params['flags']);
 
-        foreach($sources as $index=>$src)
-        {
-            if($src!="")
-            {
+		foreach($sources as $index=>$src) {
+			if($src!=""){
 		$source = $this->treat_base64_from_post($src);
-		$insert = $this->insert_email($source,$dest_folder,$timestamps[$index],$flags[$index]);
+ 		        $insert = $this->insert_email($source, mb_convert_encoding( $dest_folder,"ISO-8859-1","UTF-8"), $timestamps,$flags[$index]); 
             }
 	}
-        
         return $insert;
     }
@@ -4357,10 +4991,4 @@
 			$msg_user = "Sem mensagem!"; 
  		         
-		$toaddresses = $_SESSION['phpgw_info']['expressomail']['server']['sugestoes_email_to'];  
- 		$toaddress   = explode(",", $toaddresses);       
- 		                 
- 		for($i=0; $i<count($toaddress); $i++) 
-			$toaddress[$i] = trim($toaddress[$i]); 
- 		                 
 		$toname       = $_SESSION['phpgw_info']['expressomail']['user']['fullname']; 
  		 
@@ -4372,10 +5000,155 @@
  		                "$msg_user</body><br><br><hr>"; 
  		             
+ 		require_once $_SESSION['rootPath'] . '/API/class.servicelocator.php';
  		$mailService = ServiceLocator::getService('mail');      
- 		$mailService->addAttachment($mail_content, 'report.eml', 'application/text'); 
- 		$mailService->send($toaddress, $GLOBALS['phpgw_info']['user']['email'], $title, $body); 
+ 		$mailService->addStringAttachment($mail_content, 'report.eml', 'application/text'); 
+ 		$mailService->sendMail($_SESSION['phpgw_info']['expressomail']['server']['sugestoes_email_to'], $GLOBALS['phpgw_info']['user']['email'], $title, $body); 
 	} 
 	
+	function array_msort($array, $cols)
+	{
+		$colarr = array();
+		foreach ($cols as $col => $order) {
+			$colarr[$col] = array();
+			foreach ($array as $k => $row) { $colarr[$col]['_'.$k] = strtolower($row[$col]); }
+		}
+		$params = array();
+		foreach ($cols as $col => $order) {
+			$params[] =& $colarr[$col];
+			$params = array_merge($params, (array)$order);
+		}
+		call_user_func_array('array_multisort', $params);
+		$ret = array();
+		$keys = array();
+		$first = true;
+		foreach ($colarr as $col => $arr) {
+			foreach ($arr as $k => $v) {
+				if ($first) { $keys[$k] = substr($k,1); }
+				$k = $keys[$k];
+				if (!isset($ret[$k])) $ret[$k] = $array[$k];
+				$ret[$k][$col] = $array[$k][$col];
+			}
+			$first = false;
+		}
+		
+		return $ret;
+
+	}
+        
+        function parseCriteriaSearchMail($search)
+        {
+            $criteria = '';
+            $searchArray = explode(' ', $search);
+
+            foreach ($searchArray as $v)
+                if(trim($v) !== '' )
+                    $criteria .= 'TEXT "'.$v.'" ' ;
+           
+            return $criteria;
+        }
+        
+	function quickSearchMail( $params )
+	{
+		$return = array();
+		$return['folder'] = $params['folder'];
+		if(!is_array($params['folder']))
+			$params['folder'] = array( $params['folder'] );
+		
+		if(!isset($params['sort']))
+			$params['sort'] = SORTDATE;
+				
+		$params['search'] = mb_convert_encoding($params['search'], 'UTF-8',mb_detect_encoding($params['search'].'x', 'UTF-8, ISO-8859-1'));
+		
+		$i = 0;		
+		if(!isset($params['page'])) $params['page'] = 0;
+		$end = ($this->prefs['max_email_per_page'] * ((int)$params['page'] + 1));	
+		$ini = $end - $this->prefs['max_email_per_page'] ;
+		$count = 0;
+		
+                $search = $this->parseCriteriaSearchMail($params['search']);
+		                
+		foreach ($params['folder'] as $folder) 
+		{
+			$imap = $this->open_mbox( $folder ) ;
+			$msgIds = imap_sort( $imap , SORTDATE , 0 , SE_UID , $search ,'UTF-8');
+						
+			$count += count($msgIds);  
+			
+			foreach ($msgIds as $ii => $v)
+			{				
+				$msg = imap_headerinfo ( $imap,  imap_msgno($imap, $v) );
+				$return['msgs'][$i]['from'] = '';
+				
+				$from = $msg->from[0]->mailbox;
+				if($msg->from[0]->personal != "")
+					$from = $msg->from[0]->personal;
+				$return['msgs'][$i]['from'] 	= mb_convert_encoding($this->decode_string($from), 'UTF-8'); 
+				
+				$return['msgs'][$i]['subject'] = ' ';
+				
+				$subject = imap_mime_header_decode($msg->subject);
+				foreach ($subject as $tmp)
+					$return['msgs'][$i]['subject'] .= mb_convert_encoding($tmp->text, 'UTF-8');
+				
+				$return['msgs'][$i]['flag'] = ' ';
+				$return['msgs'][$i]['flag'] .= $msg->Unseen ? $msg->Unseen : '';
+				$return['msgs'][$i]['flag'] .= $msg->Recent ? $msg->Recent : '';	
+				$return['msgs'][$i]['flag'] .= $msg->Flagged ? $msg->Flagged : '';	
+				$return['msgs'][$i]['flag'] .= $msg->Draft ? $msg->Draft : '';	
+				$return['msgs'][$i]['flag'] .= $msg->Answered ? $msg->Answered : '';	
+				$return['msgs'][$i]['flag'] .= $msg->Deleted ? $msg->Deleted : '';	
+				
+				$return['msgs'][$i]['udate'] = gmdate("d/m/Y",$msg->udate + $this->functions->CalculateDateOffset()); 
+				$return['msgs'][$i]['udatecomp'] = substr ($return['msgs'][$i]['udate'], -4) ."-". substr ($return['msgs'][$i]['udate'], 3, 2) ."-". substr ($return['msgs'][$i]['udate'], 0, 2);
+			    $return['msgs'][$i]['date'] =   $msg->udate;
+				$return['msgs'][$i]['size'] =  $msg->Size;
+				$return['msgs'][$i]['boxname'] = $folder;
+				$return['msgs'][$i]['uid'] = $v;
+				$i++;
+			} 	
+		}
+		
+		$return['num_msgs'] = $count;
+		
+		if(!isset($return['msgs']))
+			$return['msgs'] = array();
+		
+		define('SORTBOX', 69);
+		define('SORTWHO', 2);
+		define('SORTBOX_REVERSE', 69);
+		define('SORTWHO_REVERSE', 2);
+		define('SORTDATE_REVERSE', 0);
+		define('SORTSUBJECT_REVERSE', 3);
+		define('SORTSIZE_REVERSE', 6);
+		
+		switch (constant( $params['sort'] )){
+			case 0 : $sA = 'date'; break;
+			case 2 : $sA = 'from'; break;
+			case 69 : $sA = 'boxname'; break;
+			case 3 : $sA = 'subject'; break;
+			case 6 : $sA = 'size'; break;
+	} 
 	
+		$return['msgs'] = $this->array_msort($return['msgs'] , array( $sA => SORT_ASC));
+			
+		if(strpos($params['sort'],'REVERSE') !== false)
+			$return['msgs'] = array_reverse($return['msgs']);	
+				
+		
+		$k = -1;
+		$nMsgs = array();
+		
+		foreach ($return['msgs'] as $v)
+		{		
+			$k++;
+			if($k < $ini || $k >= $end ) continue;			
+			$nMsgs[] = $v;
+		}
+		$return['msgs'] = $nMsgs;
+		$return = json_encode($return);		
+		$return = base64_encode($return);
+	
+		return $return;
+	}
 	
     function get_quota_folders(){ 
@@ -4416,4 +5189,23 @@
 	    return $data; 
     }  
+    
+    function getaclfrombox($mail)
+        {
+                $mailArray = explode('@', $mail);
+                $boxacl = $mailArray[0];
+                $return = array();
+
+                if(!$this->mbox)
+                     $this->open_mbox();
+
+                $mbox_acl = imap_getacl($this->mbox, 'user' . $this->imap_delimiter . $boxacl);
+
+                foreach ($mbox_acl as $user => $acl)
+                {
+                        if ($user != $boxacl )
+                            $return[$user] = $acl;
+                }
+                return $return;
+        }
 }
 ?>
